var emptyPosition = '8/8/8/8/8/8/8/8 w - - 0 1'; 
var board,
    statusEl = $('#status'),
    fieldActionEl = $('#fieldAction'),
    fieldValueEl = $('#fieldValue'),
    selectValueEl1 = $('#selectValue1'),
    selectValueEl2 = $('#selectValue2'),
    fieldResultEl = $('#fieldResult'),
    instructionLinkEl = $('#instructionLink'),
    modeLinkEl = $('#modeLink'),
    clockEl = $('#clock');
var game = {
 squareClicked: '',
 inGame: 0,
 squareSelected: '',
 fieldColor: '',
 count: 0,
 clicks: 0
};

var onMouseoutSquare = function(square, piece, position, orientation) { //Мышка уходит с клетки
 if (game.inGame > 1) return;
 game.squareClicked = square.toUpperCase();
 removeGreySquares();
};

var onMouseoverSquare = function (square, piece, position, orientation) { //Мышка входит на поле
 if (game.inGame > 1) return;
 game.squareClicked = square.toUpperCase();
 greySquare (square);
};

var removeGreySquares = function() { //Убрать фон
 $('#board .square-55d63').css('background', '');
};

var greySquare = function (square) { //Непосредственно функция подсветки полей
 var squareEl = $('#board .square-' + square);
 var background = '#99ff99'; //Цвет подсветки белых полей
 if (squareEl.hasClass('black-3c85d') === true) {
  background = '#03c03c'; //Цвет подсветки чёрных полей
 }
 squareEl.css('background', background);
};

var updateStatus = function(str) { //Обновление статуса
 var status = str;
 statusEl.html(status);
};

var cfg = { //Конфигурация доски
 draggable: false,
 showNotation: false,
 position: emptyPosition,
 onMouseoutSquare: onMouseoutSquare,
 onMouseoverSquare: onMouseoverSquare
};

$(document).on('click','html *',function() {
 if (game.inGame == 2) { //  $(this) = current element that clicked
  fieldResultEl.html('Введи название поля - букву и цифру');
  fieldValueEl.focus();
 }
});

var element1 = document.querySelector('.board');
element1.addEventListener ("click", function(e) {
 if (game.inGame == 1) {
  if (game.squareClicked == game.squareSelected) {
   fieldResultEl.html('Верно! Это было поле '+game.squareSelected);
   game.count++;
   var f = '';
   do { 
    f = getRandomNotation(); 
    if (f != game.squareSelected) break;
   } while (1);
   game.squareSelected = f;
   fieldValueEl.val(game.squareSelected);
  }
  else {
   fieldResultEl.html('<font color="red">Ошибка, попробуй ещё раз...</font>');
  }
  game.clicks++;
  updateStatus('игра 1, счёт '+game.count+' из '+game.clicks);
 }
 else if (game.inGame == 2) {
  fieldResultEl.html('Введи название поля - букву и цифру');
  fieldValueEl.focus();
 }
 else if (game.inGame == 3) {
  fieldResultEl.html('Выбери, белым или чёрным должно быть поле');
 }
/* else { //панель всё равно скрыта
  fieldResultEl.html('Сначала выбери игру 1, 2 или 3');
 } */
}, false);
board = ChessBoard('board', cfg);

updateStatus('выбери игру 1, 2 или 3 в меню');

function switchShow (id) { //Переключалка видимости для вывода инструкции
 var div=document.getElementById ('instructionBox');
 div.style.display = div.style.display == "none" ? "block" : "none";
 instructionLinkEl.html(div.style.display == "block" ? "СКРЫТЬ ПОМОЩЬ" : "ПОМОЩЬ");
 return false;
}

function switchMode () { 
 cfg.showNotation = (cfg.showNotation==false ? true : false);
 modeLinkEl.html((cfg.showNotation==false ? 'включить координаты' : 'убрать координаты'));
 board.resize();
 if (game.inGame>1) { selectGame(game.inGame,false); }
}

function reloadMe() { //Перезагрузка
 window.location.reload(true);
}

function initGame (num) {
 game.inGame = num;
 game.squareClicked = game.squareSelected = game.fieldColor = '';
 game.count = game.clicks = 0;
 fieldResultEl.html('');
}

var element2 = document.querySelector('.fieldValue');
element2.addEventListener ("change", function(e) {
 if (game.inGame != 2) return;
 var inputField = fieldValueEl.val().toUpperCase();
 if (inputField.length != 2) return;
 if (inputField == game.squareSelected) {
  fieldResultEl.html('Верно! Это было поле '+game.squareSelected);
  game.count++;
  var f = '';
  do { 
   f = getRandomNotation(); 
   if (f != game.squareSelected) break;
  } while (1);
  removeGreySquares();
  greySquare(f.toLowerCase());
  game.squareSelected = f;
 }
 else {
  fieldResultEl.html('<font color="red">Ошибка, попробуй ещё раз...</font>');
 }
 fieldValueEl.val('');
 game.clicks++;
 updateStatus ('игра 2, счёт '+game.count+' из '+game.clicks);
},false);

function selectGame (num,initAgain) {
 board.resize();
 var div = document.getElementById ('fieldBox');
 div.style.display = "block";
 fieldValueEl.show(); selectValueEl1.hide(); selectValueEl2.hide();
 if (initAgain) {
  initGame(num);
  updateStatus('выбрана игра '+game.inGame);
 }
 if (game.inGame == 1) {
  if (!initAgain) return;
  fieldActionEl.html('Щёлкни по полю ');
  game.squareSelected = getRandomNotation();
  fieldValueEl.val(game.squareSelected);
 }
 else if (game.inGame == 2) {
  fieldActionEl.html('Введи название подсвеченного поля и нажми Enter: ');
  fieldValueEl.val('');
  fieldValueEl.focus();
  removeGreySquares();
  if (initAgain) {
   var f = getRandomNotation();
   greySquare(f.toLowerCase());
   game.squareSelected = f;
  }
  else {
   greySquare(game.squareSelected.toLowerCase());
  }
 }
 else if (game.inGame == 3) {
  fieldActionEl.html('Какой цвет должен быть у подсвеченного поля? ');
  fieldValueEl.hide(); selectValueEl1.show(); selectValueEl2.show();
  removeGreySquares();
  removeColors();
  if (initAgain) {
   var f = getRandomNotation();
   addSquareColor(f.toLowerCase());
   game.squareSelected = f;
  }
  else {
   addSquareColor(game.squareSelected.toLowerCase());
  }
 }
}

function getFieldColor (r,c) { 
 return (r%2==c%2 ? 'b' : 'w'); 
}

function getRandomNotation () {
 var rows = new Array ('A','B','C','D','E','F','G','H');
 var rowIndex = Math.floor(Math.random() * rows.length);
 var row = rows[rowIndex]; 
 var cols = new Array ('1','2','3','4','5','6','7','8');
 var colIndex = Math.floor(Math.random() * cols.length);
 var col = cols[colIndex];
 game.fieldColor = getFieldColor(rowIndex,colIndex);
 return row+col;
}

function removeColors () {
 var rows = new Array ('a','b','c','d','e','f','g','h'); 
 var cols = new Array ('1','2','3','4','5','6','7','8');
 for (var i=0; i<rows.length; i++)
 for (var j=0; j<cols.length; j++) {
  var square = '' + rows[i] + cols[j];
  var squareEl = $('#board .square-' + square);
  squareEl.css('background', '#666666');
  squareEl.css('background-image', 'url(img/background80x80.png)');
 }
}

function addSquareColor (square) {
 var squareEl = $('#board .square-' + square);
 squareEl.css('background', '#03c03c');
}

function selectButton (n) {
 if (n==1 && game.fieldColor=='w' || n==2 && game.fieldColor=='b') {
  fieldResultEl.html('Верно! Цвет поля '+game.squareSelected + ' - '+(game.fieldColor=='w'?'белый':'чёрный'));
  game.count++;
 }
 else {
  fieldResultEl.html('<font color="red">Ошибка, '+game.squareSelected+'- это '+(game.fieldColor=='w'?'белое':'чёрное')+' поле</font>');
 }
 game.clicks++;
 updateStatus('игра 3, счёт '+game.count+' из '+game.clicks);
 var f = '';
 do { 
  f = getRandomNotation(); 
  if (f != game.squareSelected) break;
 } while (1);
 removeGreySquares();
 removeColors();
 addSquareColor (f.toLowerCase());
 game.squareSelected = f;
}

function clock (h,m,s) {
 clockEl.html((h>0?h+':':'')+(m<10?'0':'')+m+':'+(s<10?'0':'')+s);
 s++;
 if (s>59) { 
  s=0; m++; 
  if (m>59) {
   m=0; h++;
  }
 }
 window.setTimeout('clock('+h+','+m+','+s+')',1000);
}

clock (0,0,0);
